#include <time.h>
#include <stdlib.h>
#include <iostream.h>

#include "search.h"
#include "analyse.h"
#include "genmove.h"
#include "analyse.h"
#include "board.h"
#include "ini_file.h"
#include "db.h"

#define NOCOMPLEXITY_MANAGEMENT 100000

int complexity;
int endprocess;


void print(MOVE move)
{
      cout << (char)(PS_GetX(move.start)+96) << (int)PS_GetY(move.start);
      cout << (char)(PS_GetX(move.stop)+96) << (int)PS_GetY(move.stop);
}

void SE_Sort(float *num,MOVE *move,char nb,bool type)
{
 float Iswap;
 MOVE  Mswap;
 for(char i=0;i<nb;i++)
 for(char index=0;index<nb-1;index++)
 {
   if ((num[index+1]>num[index])&&(type==false)){
    Iswap = num[index];
    num[index] = num[index+1];
    num[index+1] = Iswap;
    Mswap = move[index];
    move[index] = move[index+1];
    move[index+1] = Mswap;
   }
   if ((num[index+1]<num[index])&&(type==true)){
    Iswap = num[index];
    num[index] = num[index+1];
    num[index+1] = Iswap;
    Mswap = move[index];
    move[index] = move[index+1];
    move[index+1] = Mswap;
   }
 }
}

SLINT SE_Analyse(BOARD board,bool color,int level,int maxlevel,float alpha_beta)
{
  MOVE   result[MAX_NB_RESULT];
  SLINT  current_result,best_result;
  BOARD  board_tmp;
  float  alpha_beta_up;
  if (((level>=maxlevel)&&(GN_Complexity(board) < complexity))||(level>=endprocess))
  {
    return AN_Analyse(board);
  }

  if (color == WHITE) alpha_beta_up = -MATE_VALUE;
  if (color == BLACK) alpha_beta_up =  MATE_VALUE;
  int nbmove = GN_Generate(board,color,result);
  for(int I=0;I<nbmove;I++)
  {
    board_tmp = BO_Move(board,result[I]);
    current_result = SE_Analyse(board_tmp,!color,level+1,maxlevel,alpha_beta_up);
    if ((current_result ==  MATE_VALUE)&&(color==WHITE)) return MATE_VALUE;
    if ((current_result == -MATE_VALUE)&&(color==BLACK)) return -MATE_VALUE;
    if (I==0) best_result = current_result;
    if (color == WHITE) {
       if (best_result<current_result) best_result = current_result;
       if (current_result == MATE_VALUE) return MATE_VALUE;
       if (current_result>alpha_beta_up) alpha_beta_up = current_result;
       if (current_result>alpha_beta) return best_result;
    }
    if (color == BLACK) {
       if (best_result>current_result) best_result = current_result;
       if (current_result == -MATE_VALUE) return -MATE_VALUE;
       if (current_result<alpha_beta_up) alpha_beta_up = current_result;
       if (current_result<alpha_beta) return best_result;
    }


  }
  return best_result;
}

MOVE SE_Search(BOARD board,bool color)
{
  MOVE     move[MAX_NB_RESULT];
  float    result[MAX_NB_RESULT];
  SLINT    current_result,best_result;
  MOVE     db_move,best_move;
  BOARD    board_tmp;
  INI_FILE conf;
  int      nb_db;
  float    alpha_beta_up;

  conf.read("conf.ini");
  int level      = conf.getintvalue("ALGO", "level");
  int preprocess = conf.getintvalue("ALGO", "prelevel");
      endprocess = conf.getintvalue("ALGO", "maxlevel");

  complexity = NOCOMPLEXITY_MANAGEMENT; // disactivation

// preprocessing
  interface_update(0.0);
  if (color == WHITE) alpha_beta_up = -MATE_VALUE;
  if (color == BLACK) alpha_beta_up =  MATE_VALUE;
  int nbmove = GN_Generate(board,color,move);
  for(int I=0;I<nbmove;I++)
  {
    interface_update((float)I/nbmove);
    board_tmp = BO_Move(board,move[I]);
    current_result = SE_Analyse(board_tmp,!color,1,preprocess,alpha_beta_up);
    if (move[I].start == NOMOVE) continue;
    if (color == WHITE) {
       if (current_result == MATE_VALUE) return move[I];
       if (current_result>alpha_beta_up) alpha_beta_up = current_result;
    }
    if (color == BLACK) {
       if (current_result == -MATE_VALUE) return move[I];
       if (current_result<alpha_beta_up) alpha_beta_up = current_result;
    }
    result[I] = current_result;
  }
  interface_update(1.0);

// sort preresult
  SE_Sort(result,move,nbmove,color);

// final calculation
  complexity = conf.getintvalue("ALGO", "complexity");
  interface_update(0.0);
  if (color == WHITE) alpha_beta_up = -MATE_VALUE;
  if (color == BLACK) alpha_beta_up =  MATE_VALUE;
  for(int I=0;I<nbmove;I++)
  {
    interface_update((float)I/nbmove);
    board_tmp = BO_Move(board,move[I]);
    current_result = SE_Analyse(board_tmp,!color,1,level,alpha_beta_up);
    if (color == WHITE) {
       if (current_result == MATE_VALUE) return move[I];
       if (current_result>alpha_beta_up) alpha_beta_up = current_result;
    }
    if (color == BLACK) {
       if (current_result == -MATE_VALUE) return move[I];
       if (current_result<alpha_beta_up) alpha_beta_up = current_result;
    }
    result[I] = current_result;
  }

// data base access
  if (color == WHITE) {
    nb_db = DB_FindMove(board,1);
    for(int I=0;I<nbmove;I++) {
      for(int J=0;J<nb_db;J++) {
        db_move=DB_GetMove(J);
        if ((move[I].start == db_move.start)&&(move[I].stop == db_move.stop)){
          result[I] += 0.1;
        }
      }
    }
    nb_db = DB_FindMove(board,0);
    for(int I=0;I<nbmove;I++) {
      for(int J=0;J<nb_db;J++) {
        db_move=DB_GetMove(J);
        if ((move[I].start == db_move.start)&&(move[I].stop == db_move.stop)){
          result[I] += 0.01;
        }
      }
    }
  }
  if (color == BLACK) {
    nb_db = DB_FindMove(board,-1);
    for(int I=0;I<nbmove;I++) {
      for(int J=0;J<nb_db;J++) {
        db_move=DB_GetMove(J);
        if ((move[I].start == db_move.start)&&(move[I].stop == db_move.stop)){
          result[I] -= 0.1;
        }
      }
    }
    nb_db = DB_FindMove(board,0);
    for(int I=0;I<nbmove;I++) {
      for(int J=0;J<nb_db;J++) {
        db_move=DB_GetMove(J);
        if ((move[I].start == db_move.start)&&(move[I].stop == db_move.stop)){
          result[I] -= 0.01;
        }
      }
    }
  }

// sort result
  SE_Sort(result,move,nbmove,color);

  for (int I=0;I<nbmove;I++) {
      print(move[I]);
      cout << " => " << result[I] << "\n";
  }

  for(int I=0;I<nbmove;I++) {
     if (move[I].start == NOMOVE) continue;
     interface_update(1.0);
     return move[I];
  }
  return move[1]; // match nul
}
